#include "tk499.h" 
#include "LCD.h"
#include "ASCII.h"
#include "GB1616.h"	//16*16ģ

__align(256) u32 LTDC_Buf[XSIZE_PHYS*YSIZE_PHYS];

void LCD_delay(volatile int time)  //ʱ
{
	volatile u32 i;	
	while(time--)
	for(i=500;i>0;i--);
}
void GPIO_RGB_INIT(void)
{
	
	GPIO_InitTypeDef GPIO_InitStructure;//GPIOʼṹ

	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB | RCC_AHBPeriph_GPIOD | RCC_AHBPeriph_GPIOE, ENABLE);
	
	//DE=PB4, PCLK=PB5, HSYNC=PB6, VSYNC=PB7
	GPIO_InitStructure.GPIO_Pin  =  GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	
	
	//========== PA0 򰴼 С ʼΪ
	GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_0;   
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD;  
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	//                           lcd_reset:PD6    LCD_Black_Light On Off  :PD8
	GPIO_InitStructure.GPIO_Pin  =  GPIO_Pin_6 | GPIO_Pin_8;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(GPIOD, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin  =  GPIO_Pin_7;//ע⣺INTϵʱĵƽ״̬IICĵַ
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_Init(GPIOD, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin  =  GPIO_Pin_14;//LED
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(GPIOB, &GPIO_InitStructure);	
	
  GPIO_InitStructure.GPIO_Pin  =  GPIO_Pin_All;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(GPIOE, &GPIO_InitStructure);
	
	GPIO_PinAFConfig(GPIOB, GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7, GPIO_AF_LTDC); //PB4~7ΪLTDCͬź
	GPIO_PinAFConfig(GPIOE, GPIO_Pin_All, GPIO_AF_LTDC); //GPIOEеIOȫΪLTDC
}
static void LCD_Reset(void)
{
	//ע⣬ڿѧеøλҲ 
		LCD_RST(0);
    LCD_delay(200);					   
    LCD_RST(1);		 	 
    LCD_delay(200);			   
}
void LTDC_Clock_Set(void)	//LTDCʱ
{
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_LTDC, ENABLE);
	RCC->CR |= 1<<28;
	RCC->PLLDCKCFGR = 0x1<<16;  //Ƶϵ 0~3 --> 2,4,6,8
	RCC->PLLLCDCFGR = 5<<6;   	//Ƶϵ
}
void set_resolutionXX(LCD_FORM_TypeDef* LCD_FORM)
{
    u32 aHorStart;
    u32 aHorEnd;
    u32 aVerStart;
    u32 aVerEnd;

    aHorStart = LCD_FORM->blkHorEnd + 1;
    aHorEnd = aHorStart + LCD_FORM->aHorLen;  
    aVerStart = LCD_FORM->blkVerEnd + 1 ;
    aVerEnd = aVerStart + LCD_FORM->aVerLen;

		LTDC->P_HOR = aHorEnd;//ܿ
    LTDC->HSYNC = (LCD_FORM->sHsyncStart <<16 )|LCD_FORM->sHsyncEnd;//ˮƽͬźʼͽλڱɫм
    LTDC->A_HOR = (aHorStart<<16)|aHorEnd;//ˮƽʼͽ
    LTDC->A_HOR_LEN = LCD_FORM->aHorLen ;//ˮƽ
    LTDC->BLK_HOR = (0<<16)|LCD_FORM->blkHorEnd;//ʼͽ0~ַ	
    LTDC->P_VER =  aVerEnd;
    LTDC->VSYNC = (LCD_FORM->sVsyncStart<<16)|LCD_FORM->sVsyncEnd;
    LTDC->A_VER = (aVerStart<<16)|aVerEnd;
    LTDC->A_VER_LEN = LCD_FORM->aVerLen ;
		LTDC->BLK_VER = (0<<16)|LCD_FORM->blkVerEnd;
}


void Set_LCD_Timing_to_LTDC(void)
{
    LCD_FORM_TypeDef LCD_FORM;
    LTDC->OUT_EN = 0;
    LTDC->DP_ADDR0 = (u32)LTDC_Buf;//0ַ
//    LTDC->DP_ADDR1 = (u32)(LTDC_Buf + SDRAM_RGB_OFFSET);//һַ
    LTDC->BLK_DATA = 0x0000;//ɫ

		LCD_FORM.sHsyncStart = 0x28; //2  
    LCD_FORM.sHsyncEnd = 0xa7;  //3
    LCD_FORM.aHorLen = 800 - 1;  //480 
    LCD_FORM.blkHorEnd = 0x8f;//0x27

    LCD_FORM.sVsyncStart = 0x18; //0x28
    LCD_FORM.sVsyncEnd = 0x20;   //0xa7
    LCD_FORM.aVerLen= 480 - 1;   //800
    LCD_FORM.blkVerEnd = 0x15;//0xc7
	
    set_resolutionXX(&LCD_FORM);

		LTDC->VI_FORMAT = 0;
		LTDC->POL_CTL = 0x3;
		LTDC->OUT_EN |= 0x107;
}
void LTDC_IRQHandler(void)
{
    LTDC->INTR_CLR = 2;
    LTDC->DP_SWT ^= 1;//ʾͼƬ
    if(LTDC->DP_SWT !=0 )
    {
    }
    else
    {
    }
//    if(LTDC->INTR_STA & 2)
//    {

//    }
}
/**********************************************
Lcd亯

ڲxStart xʼ
          ySrart yֹ
          xLong Ҫѡεx򳤶
          yLong  Ҫѡεy򳤶
ֵ
***********************************************/
void Lcd_ColorBox(u16 xStart,u16 yStart,u16 xLong,u16 yLong,u32 Color)
{
//	u16 i,j;
//	u32 temp;
//	temp = YSIZE_PHYS*xStart;
//	for(i=0;i<yLong;i++)
//	{
//		for(j=0;j<xLong;j++)
//		LTDC_Buf[yStart+i+YSIZE_PHYS*j+temp]=Color;
//	}
	
	u16 i,j;
	u32 temp;
	temp = XSIZE_PHYS*yStart;
	for(i=0;i<yLong;i++)
	{
		for(j=0;j<xLong;j++)
		LTDC_Buf[xStart+j+XSIZE_PHYS*i+temp]=Color;
	}
}
void LCD_Initial(void) //LCDʼ
{    
	GPIO_RGB_INIT();//ʼҺGPIO
	LCD_Reset();
	LTDC_Clock_Set();
	Set_LCD_Timing_to_LTDC();
	Lcd_Light_ON;//򿪱
}
/******************************************
Lcdͼ
ܣLcdָλͼ
ڲ
					(x,y): ͼƬϽʼ
					(pic_H,pic_V): ͼƬĿ
					 pic  ָ洢ͼƬָ
******************************************/
void LCD_Fill_Pic(u16 x, u16 y,u16 pic_H, u16 pic_V, u32* pic)
{
//	u16 i,j;
//	u32 Xstart,k=0;
//	Xstart = YSIZE_PHYS*x;
//	for(i=0;i<pic_V;i++)
//	{
//		for(j=0;j<pic_H;j++)
//		LTDC_Buf[Xstart+i+YSIZE_PHYS*j+y]=pic[k++];
//	}
	
	u16 i,j;
	u32 temp,k=0;
	temp = XSIZE_PHYS*y;
	for(i=0;i<pic_V;i++)
	{
		for(j=0;j<pic_H;j++)
		LTDC_Buf[x+j+XSIZE_PHYS*i+temp]=pic[k++];
	}
	
//	u16 i,j;
//	u32 Ystart,k=0;
//	Ystart = YSIZE_PHYS*y;
//	for(i=0;i<pic_V;i++)
//	{
//		for(j=0;j<pic_H;j++)
//		LTDC_Buf[x+j+YSIZE_PHYS*i+Ystart]=pic[k++];
//	}
}
//=============== xy ϴһɫΪColorĵ ===============
void DrawPixel(u16 x, u16 y, int Color)
{

//	LTDC_Buf[y+YSIZE_PHYS*x] = Color; //ת90
	LTDC_Buf[x+XSIZE_PHYS*y] = Color;  //ת
						  
}
/**********8*16 ASCII ʾ*************
(x,y): ʾĸʼ
num:   Ҫʾַ:" "--->"~"
fColor ǰɫ
bColor ɫ
flag:  бɫ(1)ޱɫ(0)
*********************************************/
void SPILCD_ShowChar(unsigned short x,unsigned short y,unsigned char num, unsigned int fColor, unsigned int bColor,unsigned char flag) 
{       
	unsigned char temp;
	unsigned int pos,i,j;  

	num=num-' ';//õƫƺֵ
	i=num*16; 	
	for(pos=0;pos<16;pos++)
		{
			temp=nAsciiDot[i+pos];	//ͨASCII
			for(j=0;j<8;j++)
		   {                 
		        if(temp&0x80)
							DrawPixel(x+j,y,fColor);
						else 
							if(flag) DrawPixel(x+j,y,bColor); //ɫ־flagΪ1
							temp<<=1; 
		    }
			 y++;
		}		 
}  

/**********дһ16x16ĺ*****************
(x,y): ʾֵʼ
c[2]:  Ҫʾĺ
fColor ǰɫ
bColor ɫ
flag:  бɫ(1)ޱɫ(0)
*********************************************/
void PutGB1616(unsigned short x, unsigned short  y, unsigned char c[2], unsigned int fColor,unsigned int bColor,unsigned char flag)
{
	unsigned int i,j,k;
	unsigned short m;
	for (k=0;k<64;k++) { //64ʾԽֿеĸѭѯ
	  if ((codeGB_16[k].Index[0]==c[0])&&(codeGB_16[k].Index[1]==c[1]))
			{ 
    	for(i=0;i<32;i++) 
			{
				m=codeGB_16[k].Msk[i];
				for(j=0;j<8;j++) 
				{		
					if((m&0x80)==0x80) {
						DrawPixel(x+j,y,fColor);
						}
					else {
						if(flag) DrawPixel(x+j,y,bColor);
						}
					m=m<<1;
				} 
				if(i%2){y++;x=x-8;}
				else x=x+8;
		  }
		}  
	  }	
	}

/**********ʾһ*****************
(x,y): ַʼ
*s:    Ҫʾַָ
fColor ǰɫ
bColor ɫ
flag:  бɫ(1)ޱɫ(0)
*********************************************/
void LCD_PutString(unsigned short x, unsigned short y, char *s, unsigned int fColor, unsigned int bColor,unsigned char flag) 
	{
		unsigned char l=0;
		while(*s) 
			{
				if( (unsigned char)*s < 0x80) 
						{
							SPILCD_ShowChar(x+l*8,y,*s,fColor,bColor,flag);
							s++;l++;
						}
				else
						{
							PutGB1616(x+l*8,y,(unsigned char*)s,fColor,bColor,flag);
							s+=2;l+=2;
						}
			}
	}
